classification
Title: Add 'annotations' to the glossary
Type: enhancement Stage: patch review
Components: Documentation Versions: Python 3.8, Python 3.7, Python 3.6
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: docs@python Nosy List: adelfino, cheryl.sabella, docs@python, gvanrossum, levkivskyi, lukasz.langa, matrixise, r.david.murray
Priority: normal Keywords: easy, patch

Created on 2018-02-04 23:13 by cheryl.sabella, last changed 2018-05-26 17:44 by adelfino.

Pull Requests
URL Status Linked Edit
PR 6657 merged adelfino, 2018-04-30 17:09
PR 6821 closed adelfino, 2018-05-14 19:23
PR 6829 merged adelfino, 2018-05-14 20:22
PR 7127 merged adelfino, 2018-05-26 12:57
PR 7128 merged adelfino, 2018-05-26 13:20
PR 7131 open adelfino, 2018-05-26 17:44
Messages (31)
msg311796 - (view) Author: Stéphane Wirtel (matrixise) * Date: 2018-02-07 16:09
There is a description of the annotation in the Glossary, but with 'function annotation'

maybe we could rename 'function annotation' by 'annotation'
msg311900 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-02-09 17:51
This is a rather small change, so probably it would be easier to discuss it in a PR.
msg311904 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2018-02-09 19:35
PRs are for discussing proposed text/code.  Discussion of whether or not to do this belongs here.  (I have no opinion on this issue myself.)
msg311905 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-02-09 19:43
I wanted to say implicitly that I like the idea, and that we should figure out details in a PR. But of course if someone is against this, then we should wait with a PR.
msg311907 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2018-02-09 21:26
I'm all for adding a bunch of terms related to type hints/annotations to the Glossary.
msg315953 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-04-30 17:10
I just made a PR to start working on the right wording.
msg316121 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-05-03 12:11
Guido, now that we are working on this, perhaps you can list what other terms related to type hints/annotations you were thinking for addition.
msg316143 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2018-05-03 22:55
Perhaps you can start with the more important terms from PEP 484 (and
perhaps also PEP 483, and then PEP 526 and PEP 544). E.g. start with terms
from the ToC of those PEPs.
msg316146 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-05-03 23:33
Great, I'll look into them.

It will take me some time to make a list of the new terms and write proper descriptions. Perhaps we could deliver the updates to the glossary by waves so people can make benefit of it? As in multiple PR being merged while retaining this issue open until all required terms are added.
msg316147 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2018-05-03 23:35
I'm okay with multiple PRs, but do beware that each PR requires a core dev
to open a browser window etc., so try to group them a bit. But no need to
wait for the perfect list!
msg316553 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-05-14 19:04
New changeset f2290fb19a9b1a5fbeef0971016f72683e8cd1ad by Ivan Levkivskyi (Andrés Delfino) in branch 'master':
bpo-32769: Write annotation entry for glossary (GH-6657)
https://github.com/python/cpython/commit/f2290fb19a9b1a5fbeef0971016f72683e8cd1ad
msg316557 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-05-14 19:19
Maybe we can consider backporting this to 3.7? Andrés, if you think it makes sense, you can cherry-pick the commit and open a PR against 3.7 branch.
msg316558 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-05-14 19:20
Yes, Ivan, I was thinking about that.

I think it makes sense, and I'll be glad to do it.
msg316559 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-05-14 19:24
Shouldn't we have this on 3.6 also?
msg316562 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-05-14 19:39
Yes, all this also applies to 3.6.
msg316564 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2018-05-14 19:45
Before we backport this to 3.7 and 3.6, let's iterate on the wording a bit.

I don't think the distinction between annotations and type hints is that annotations are materialized at runtime while type hints aren't. I think syntactically they are the same, but annotations are a slightly more general concept because they may be used for other purposes than to indicate the type of a variable (or argument, attribute etc.).

So IMO in

  def f():
      x: int

'int' is both an annotation and a type hint, OTOH in

  x: 'spam eggs ham'

we have an annotation that is not a type hint.
msg316566 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-05-14 19:48
> ... but annotations are a slightly more general concept because they may be used for other purposes than to indicate the type of a variable ...

Yes, I agree.
msg316568 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-05-14 19:54
I see a conflict here in that annotations can be used for other purpouses, for example variable annotations, they are heavily intended for type hinting (PEP 526 says "This PEP aims at adding syntax to Python for annotating the types of variables (including class variables and instance variables), instead of expressing them through comments")

I think it's correct to separate annotations from type hints, and say: annotations can be used for type hinting.

I can make a new PR based on master having this in mind, and then cherry picking it for 3.7/3.6.
msg316618 - (view) Author: Łukasz Langa (lukasz.langa) * (Python committer) Date: 2018-05-15 04:06
Guido, do you really want to stress at this point for Python 3.8 that annotations do not have an intended purpose? That is clearly not true.

1. PEP 526 was created purely with types in mind and was inspired by PEP 484's lack of this functionality.

2. PEP 563 defines a future import which will become the default in a future release (currently marked as 4.0). This default stops evaluating annotations at runtime, which again was inspired by the typing use case.

3. Dataclasses in PEP 557 are designed to leverage types in annotations. A few quotes from that PEP:

> A class decorator is provided which inspects a class definition for variables with type annotations as defined in PEP 526, "Syntax for Variable Annotations".

> One main design goal of Data Classes is to support static type checkers. The use of PEP 526 syntax is one example of this, but so is the design of the fields() function and the @dataclass decorator.

4. PEP 560 added support for `__class_getitem__` and `__mro_entries__` in core purely for the purpose of generic types.

5. For the above reasons, PEP 563 states that non-typing usage of annotations is deprecated:

https://www.python.org/dev/peps/pep-0563/#non-typing-usage-of-annotations
msg316646 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-05-15 12:16
What I think Guido might mean is that some type annotations are not strictly speaking type hints. For example, `dataclasses.InitVar`, is not really a type, it is just a way to indicate how constructor should be constructed. I could see similar potential features in future (like `typing.Final` discussed recently). Even `typing.ClassVar` I would say is not a type but an access qualifier.

Also for me the two terms: annotations and hints are a bit orthogonal, first is a syntax, while second is semantics. I think Guido is right that we should say something like (approximately) `annotation is a syntax to express type hints and other related metadata` or similar. The current formulation seems a bit too restrictive.
msg316648 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2018-05-15 12:20
I actually intended to say that annotations continue to be usable for
non-typing purposes (beyond ClassVar/InitVar). It may be deprecated but the
usage still exists. This is a glossary, not a manifesto.

I'm fine with adding that the main use of annotations is for type hints of
course. And I was mostly reacting to the fact that the text that was just
committed seemed to imply that 'annotation' refers to something stored at
runtime in __annotations__ while 'type hint' was a syntactic form (and this
is borne out by the omission of *local* type hints from the section on
annotations).
msg316650 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-05-15 12:24
Yes, local annotations are important and should be mentioned (maybe even with an example).
msg316674 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-05-15 15:43
Hopefully I address your comments with the last PR update.
msg316705 - (view) Author: Łukasz Langa (lukasz.langa) * (Python committer) Date: 2018-05-15 19:30
> It may be deprecated but the usage still exists. This is a glossary, not a manifesto.

Agreed.  However, based on the current wording users will argue that Python documentation itself is stressing the lack of an intended purpose for annotations, equaling the typing use case with all other use cases (including future ones).  This isn't our intent.

I think it would be clearer to change the current wording from:

> A metadata value associated with a variable, a class attribute or a
> function or method parameter or return value, that has no specific
> purpouse (i.e. it's up to the user to use it as they see fit).
> (...)
> Annotations can be used to specify :term:`type hints <type hint>`.

to:

> A metadata value associated with a variable, a class attribute or a
> function or method parameter or return value, that stores a
> :term:`type hint`.
> (...)
> Annotations can be used for other purposes unrelated to typing. This
> usage is deprecated, see :pep:`563` for details.


The `type hint` phrasing is already there, we just need to delete the word "global" that currently appears before "variable".  Note that saying that annotations in class attributes and variables have no assigned meaning contradicts PEP 526.
msg316714 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2018-05-15 20:10
Your phrasing still makes it sound like an annotation is a runtime concept
-- I think of it as a syntactic construct. (Otherwise fine.)
msg316739 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-05-15 21:56
Guido, could you point out what parts make it sound that way to you so I can change them?
msg316751 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2018-05-16 01:02
(1) The word "stores" in this paragraph:

A metadata value associated with a global variable, a class attribute or a
function or method parameter or return value, that stores a type hint.

(2) The description of how annotations are stored in __annotations__ in the
following paragraph.

(3) The omission of local variables from the lists of things in those
paragraphs that can be annotated (those are the only category whose
annotation is not stored at runtime).
msg316752 - (view) Author: Andrés Delfino (adelfino) * Date: 2018-05-16 01:10
I'm sorry, because of your comment, I believe you haven't read the last update on the PR. Could you take a look at it?

https://github.com/python/cpython/pull/6829
msg317741 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-05-26 12:43
New changeset 6e33f810c9e3a549c9379f24cf1d1752c29195f0 by Ivan Levkivskyi (Andrés Delfino) in branch 'master':
bpo-32769: A new take on annotations/type hinting glossary entries (GH-6829)
https://github.com/python/cpython/commit/6e33f810c9e3a549c9379f24cf1d1752c29195f0
msg317746 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2018-05-26 17:17
New changeset e69657df244135a232117f692640e0568b04e999 by Guido van Rossum (Andrés Delfino) in branch '3.7':
[3.7] bpo-32769: A new take on annotations/type hinting glossary entries (GH-6829) (#7127)
https://github.com/python/cpython/commit/e69657df244135a232117f692640e0568b04e999
msg317749 - (view) Author: Ivan Levkivskyi (levkivskyi) * (Python committer) Date: 2018-05-26 17:41
New changeset 717204ffcccfe04a34b6c4a52f0e844fde3cdebe by Ivan Levkivskyi (Andrés Delfino) in branch '3.6':
[3.6] bpo-32769: A new take on annotations/type hinting glossary entries (GH-6829) (GH-7128)
https://github.com/python/cpython/commit/717204ffcccfe04a34b6c4a52f0e844fde3cdebe
History
Date User Action Args
2018-05-26 17:44:11adelfinosetpull_requests: + pull_request6765
2018-05-26 17:41:15levkivskyisetmessages: + msg317749
2018-05-26 17:17:36gvanrossumsetmessages: + msg317746
2018-05-26 13:20:19adelfinosetpull_requests: + pull_request6763
2018-05-26 12:57:06adelfinosetpull_requests: + pull_request6762
2018-05-26 12:43:42levkivskyisetmessages: + msg317741
2018-05-16 01:10:23adelfinosetmessages: + msg316752
2018-05-16 01:02:12gvanrossumsetmessages: + msg316751
2018-05-15 21:56:07adelfinosetmessages: + msg316739
2018-05-15 20:10:00gvanrossumsetmessages: + msg316714
2018-05-15 19:30:03lukasz.langasetmessages: + msg316705
2018-05-15 15:43:23adelfinosetmessages: + msg316674
2018-05-15 12:24:37levkivskyisetmessages: + msg316650
2018-05-15 12:20:58gvanrossumsetmessages: + msg316648
2018-05-15 12:16:52levkivskyisetmessages: + msg316646
2018-05-15 04:06:37lukasz.langasetnosy: + lukasz.langa
messages: + msg316618
2018-05-14 20:33:57adelfinosetversions: + Python 3.6, Python 3.7
2018-05-14 20:22:44adelfinosetpull_requests: + pull_request6513
2018-05-14 19:54:57adelfinosetmessages: + msg316568
2018-05-14 19:48:44levkivskyisetmessages: + msg316566
2018-05-14 19:45:13gvanrossumsetmessages: + msg316564
2018-05-14 19:39:36levkivskyisetmessages: + msg316562
2018-05-14 19:24:21adelfinosetmessages: + msg316559
2018-05-14 19:23:06adelfinosetpull_requests: + pull_request6506
2018-05-14 19:20:52adelfinosetmessages: + msg316558
2018-05-14 19:19:03levkivskyisetmessages: + msg316557
2018-05-14 19:04:59levkivskyisetmessages: + msg316553
2018-05-03 23:35:16gvanrossumsetmessages: + msg316147
2018-05-03 23:33:39adelfinosetmessages: + msg316146
2018-05-03 22:55:08gvanrossumsetmessages: + msg316143
2018-05-03 12:11:41adelfinosetmessages: + msg316121
2018-04-30 17:10:35adelfinosetnosy: + adelfino
messages: + msg315953
2018-04-30 17:09:20adelfinosetkeywords: + patch
stage: needs patch -> patch review
pull_requests: + pull_request6353
2018-02-10 00:18:23cheryl.sabellasetstage: needs patch
2018-02-09 21:26:01gvanrossumsetmessages: + msg311907
2018-02-09 19:43:33levkivskyisetnosy: + gvanrossum
messages: + msg311905
2018-02-09 19:35:27r.david.murraysetnosy: + r.david.murray
messages: + msg311904
2018-02-09 17:51:33levkivskyisetnosy: + levkivskyi
messages: + msg311900
2018-02-07 16:09:37matrixisesetnosy: + matrixise
messages: + msg311796
2018-02-04 23:13:13cheryl.sabellacreate